from nequip.dynamics.nequip_calculator import NequIPCalculator
import ase.units as units
import torch
import ase
import numpy as np
from nequip.nn._grad_output import StressOutput
from ase.md.npt import NPT
from ase.md.velocitydistribution import MaxwellBoltzmannDistribution
from ase.io.trajectory import Trajectory
# add parent dir to sys.path to enable import
import sys
import schnetpack as spk
from nequip.data.AtomicData import AtomicData
import nequip.data.AtomicDataDict as AtomicDataDict

from ase.io import read
properties = ['energy', 'forces', 'stress']
smaller_set = spk.AtomsData('./large_data_set.db', available_properties=properties,
                            environment_provider=spk.environment.TorchEnvironmentProvider(6,
                                                                                          device=torch.device('cuda')))
torch.set_default_dtype(torch.float64)
test_model= torch.load('mil53/best/last_model.pth')
r_max=5.0
stresstest=StressOutput(energy_model=test_model.model.func)
factor=test_model.scale_by.detach().cpu().numpy()
# prepare data
mols=[]
test1=[]
rng=np.random.default_rng()
lisss=np.arange(59716,dtype=int)
rng.shuffle(lisss)
for i in lisss[:5]:

    atoms,prop=smaller_set.get_properties(int(i),['energy','forces','stress'])
    data = AtomicData.from_ase(atoms=atoms, r_max=r_max)

    data = data.to('cuda')

    # predict + extract data
    out = stresstest(AtomicData.to_AtomicDataDict(data))
    forces = out[AtomicDataDict.FORCE_KEY].detach().cpu().numpy()*factor
    energy = out[AtomicDataDict.TOTAL_ENERGY_KEY].detach().cpu().item()*factor
    stress= out[AtomicDataDict.STRESS_KEY].detach().cpu().numpy()*factor
    print(np.mean(np.abs(stress-prop['stress'])))
def transform_symmetric(pos, rvecs):
    """Transforms coordinate axes such that cell matrix is symmetric

    Parameters
    ----------

    pos : array_like
        (natoms, 3) array containing atomic positions

    rvecs : array_like
        (3, 3) array with box vectors as rows

    """
    U, s, Vt = np.linalg.svd(rvecs)
    rot_mat = np.dot(Vt.T, U.T)
    rvecs[:] = np.dot(rvecs, rot_mat)
    pos[:] = np.dot(pos, rot_mat)

dUdh = np.zeros((3, 3))



indices = [

        (0, 0), (0, 1), (0, 2),

        (1, 0), (1, 1), (1, 2),

        (2, 0), (2, 1), (2, 2),

        ]
rvecs=atoms.get_cell().view()
pos=atoms.get_positions()
atoms_temp=atoms.copy()
data = AtomicData.from_ase(atoms=atoms_temp, r_max=r_max)

data = data.to('cuda')

# predict + extract data
out = stresstest(AtomicData.to_AtomicDataDict(data))
energy111 = out[AtomicDataDict.TOTAL_ENERGY_KEY].detach().cpu().item() * factor
stress111=out[AtomicDataDict.STRESS_KEY].detach().cpu().numpy() * factor

def energy_func(pos,rvecs):
    atoms_temp.set_positions(pos)
    atoms_temp.cell=ase.cell.Cell(rvecs)
    data = AtomicData.from_ase(atoms=atoms_temp, r_max=r_max)

    data = data.to('cuda')

    # predict + extract data
    out = stresstest(AtomicData.to_AtomicDataDict(data))
    energy = out[AtomicDataDict.TOTAL_ENERGY_KEY].detach().cpu().item()*factor
    return energy
def stress_func(pos,rvecs):
    atoms_temp.set_positions(pos)
    atoms_temp.cell=ase.cell.Cell(rvecs)
    data = AtomicData.from_ase(atoms=atoms_temp, r_max=r_max)

    data = data.to('cuda')

    # predict + extract data
    out = stresstest(AtomicData.to_AtomicDataDict(data))
    stress = out[AtomicDataDict.STRESS_KEY].detach().cpu().numpy()*factor
    return stress
transform_symmetric(pos,rvecs)
energy2222=energy_func(pos,rvecs)
stress222=stress_func(pos,rvecs)
dh=0.00001
fractional = np.dot(pos, np.linalg.inv(rvecs))
for i in range(3):
    for j in range(3):
        if (i, j) in indices:
            rvecs_ = rvecs.copy()
            rvecs_[i, j] -= dh / 2

            pos_tmp   = np.dot(fractional, rvecs_)
            rvecs_tmp = rvecs_.copy()
            E_minus = energy_func(
                    pos_tmp,
                    rvecs_tmp,
                    )

            rvecs_[i, j] += dh
            pos_tmp   = np.dot(fractional, rvecs_)
            rvecs_tmp = rvecs_.copy()
            E_pluss = energy_func(
                    pos_tmp,
                    rvecs_tmp,
                    )
            dUdh[i, j] = (E_pluss - E_minus) / dh
print(rvecs@dUdh/stress222/atoms.get_volume())
# store results